

      module system_mod
!
      contains
!
!


!
! (c) sparslab module name=realli_a
!
! purpose:
!  reallocate an integer array.
!
! history:
!   original version for sparslab - tu - 16/04/2001.
!
      subroutine realli_a(ja,arrsize,arrincr,new_arrsize,ierr)
!
! parameters
!
      integer arrsize,arrincr,new_arrsize,ierr
      integer, allocatable, dimension(:) :: ja
!
! internals
!
      integer minincr
      integer, allocatable, dimension(:) :: ja_new
      double precision minincrfactor
      parameter(minincrfactor=0.2d0)
!
! start of realli_a
!
      new_arrsize=arrsize+arrincr
      if(new_arrsize.le.arrsize) then
        minincr=int(minincrfactor*dble(arrsize))
        new_arrsize=arrsize+minincr
        if(new_arrsize.le.arrsize) new_arrsize=huge(arrsize)
      end if
      allocate(ja_new(arrsize),stat=ierr)
      if(ierr.ne.0) call serr(0,2,'sparslab','realli_a', &
        ' Allocation failure',1605,2)
      call iwcopy(arrsize,ja,1,ja_new,1)
      deallocate(ja)
      allocate(ja(new_arrsize),stat=ierr)
      if(ierr.ne.0) call serr(0,2,'sparslab','realli_a', &
        ' Allocation failure',1605,2)
      call iwcopy(arrsize,ja_new,1,ja,1)
      deallocate(ja_new)
!
!  -- return
!
      return
!
! end of realli_a
!
      end subroutine realli_a
!


!

! (c) sparslab module name=reallr_a
!
! purpose:
!  reallocate an integer array.
!
! history:
!   original version for sparslab - tu - 16/04/2001.
!
      subroutine reallr_a(aa,arrsize,arrincr,new_arrsize,ierr)
!
! parameters
!
      use iotypes
      integer arrsize,arrincr,new_arrsize,ierr
      double precision, allocatable, dimension(:) :: aa
!
! internals
!
      integer minincr
      double precision, allocatable, dimension(:) :: aa_new
      double precision minincrfactor
      parameter(minincrfactor=0.2d0)
      character i_am*10
!
! start of reallr_a
!
      i_am='reallr_a'
!      write(2,*) 'arrsize',arrsize,arrincr
      new_arrsize=arrsize+arrincr
!      write(2,*) 'arrsize',new_arrsize
      if(new_arrsize.le.arrsize) then
        minincr=int(minincrfactor*dble(arrsize))
        new_arrsize=arrsize+minincr
!      write(2,*) 'arrsize',minincr,new_arrsize
        if(new_arrsize.le.arrsize) new_arrsize=huge(arrsize)
      end if
      allocate(aa_new(arrsize),stat=ierr)
!      write(2,*) 'ierr',ierr
      if(ierr.ne.0) call err(ounit,1605,i_am,2)
      call dcopy(arrsize,aa,1,aa_new,1)
      deallocate(aa)
      allocate(aa(new_arrsize),stat=ierr)
!      write(2,*) 'ierr huhu',new_arrsize,ierr
      if(ierr.ne.0) call err(ounit,1605,i_am,2)
      call dcopy(arrsize,aa_new,1,aa,1)
      deallocate(aa_new)
!
!  -- return
!
      return
!
! end of reallr_a
!
      end subroutine reallr_a
!


! (c) sparslab module name=realli3_a
!
! purpose:
!  reallocate an integer array.
!  counts with additional nlast entries.
!
! history:
!   original version for sparslab - tu - 16/04/2001.
!
      subroutine realli3_a(ja,arrsize,arrincr,new_arrsize,nlast,ierr)
!
! parameters
!
      integer arrsize,arrincr,new_arrsize,ierr,nlast
      integer, allocatable, dimension(:) :: ja
!
! internals
!
      integer minincr
      integer, allocatable, dimension(:) :: ja_new
      double precision minincrfactor
      parameter(minincrfactor=0.2d0)
!
! start of realli3_a
!
      new_arrsize=arrsize+arrincr
      if(new_arrsize.le.arrsize) then
        minincr=int(minincrfactor*dble(arrsize))
        new_arrsize=arrsize+minincr
        if(new_arrsize.le.arrsize) new_arrsize=huge(arrsize)
      end if
      allocate(ja_new(arrsize+nlast),stat=ierr)
      if(ierr.ne.0) call serr(0,2,'sparslab','realli3_a', &
        ' Allocation failure',1605,2)
      call iwcopy(arrsize+nlast,ja,1,ja_new,1)
      deallocate(ja)
      allocate(ja(new_arrsize+nlast),stat=ierr)
      if(ierr.ne.0) call serr(0,2,'sparslab','realli3_a', &
        ' Allocation failure',1605,2)
      call iwcopy(arrsize,ja_new,1,ja,1)
      call ivcopy_backward(nlast,ja_new,ja, &
        arrsize+1,new_arrsize+1)
      deallocate(ja_new)
!
!  -- return
!
      return
!
! end of realli3_a
!
      end subroutine realli3_a

! (c) sparslab module name=reallr3_a
!
! purpose:
!  reallocate an integer array.
!
! history:
!   original version for sparslab - tu - 16/04/2001.
!
      subroutine reallr3_a(aa,arrsize,arrincr,new_arrsize,nlast,ierr)
!
! parameters
!
      use iotypes
      integer arrsize,arrincr,new_arrsize,nlast,ierr
      double precision, allocatable, dimension(:) :: aa
!
! internals
!
      integer minincr
      double precision, allocatable, dimension(:) :: aa_new
      double precision minincrfactor
      parameter(minincrfactor=0.2d0)
      character i_am*10
!
! start of reallr3_a
!
      i_am='reallr3_a'
      new_arrsize=arrsize+arrincr
      if(new_arrsize.le.arrsize) then
        minincr=int(minincrfactor*dble(arrsize))
        new_arrsize=arrsize+minincr
        if(new_arrsize.le.arrsize) new_arrsize=huge(arrsize)
      end if
      allocate(aa_new(arrsize+nlast),stat=ierr)
      if(ierr.ne.0) call err(ounit,1605,i_am,2)
      call dcopy(arrsize+nlast,aa,1,aa_new,1)
      deallocate(aa)
      allocate(aa(new_arrsize+nlast),stat=ierr)
      if(ierr.ne.0) call err(ounit,1605,i_am,2)
      call dcopy(arrsize,aa_new,1,aa,1)
      call dvcopy_backward(nlast,aa_new,aa, &
        arrsize+1,new_arrsize+1)
      deallocate(aa_new)
!
!  -- return
!
      return
!
! end of reallr3_a
!
      end subroutine reallr3_a

!
      end module system_mod



      module matrix90
!
      use system_mod
!
      contains
!
!


! (c) sparslab module name=ds_eye_f90_mod
!
! purpose:
!   initialization of dynamic data structures for right-looking
!   ainv preconditioner.
!   input matrix is in csr format.
!
! history:
!   original version for sparslab - tu - 13/04/1996.
!
! parameters:
!  ii  n  number of input matrix columns.
!  ii  m  number of input matrix rows.
!  gi  ia(n+1)/ja(ia(nn+1)-1) input matrix graph.
!  mo  ic(n)/jc(ic(n)+kc(n)-1)/kc(n)/ac(ic(n)+kc(n)-1) output unit
!        matrix in dsc format.
!  ii  max_c  size of the vectors jc/ac.
!  mo  ir(n)/jr(ir(n)+kr(n)-1)/kr(n) output graph of unit matrix
!        in dsr format.
!  ii  max_r  size of the vector jr.
!  io  iendru  position of last entry in ir/jr/kr.
!  io  iendlu  position of last entry in ic/jc/kc/ac.
!  ii  idistr  type of the distribution pattern of the dsc format.
!  ii  idistc  type of the distribution pattern of the dsr format.
!  ii  lsize  size of the distance between entries in ds* formats.
!
!
! make_explicit_interface
!
      subroutine ds_eye_f90_mod(n,m,ia,ja,ic,jc,kc,ac,max_c, &
        ir,jr,kr,max_r,                                      &
        iendru,iendlu,idistr,idistc,lsize,ierr)
!
! parameters
!
      implicit none
      integer n,m,max_r,max_c,lsize,ierr
      integer idistr,idistc,len
      integer :: ia(*),ja(*)
      integer, allocatable :: ir(:),jr(:),kr(:),ic(:),jc(:),kc(:)
      double precision, allocatable :: ac(:)
      integer iendru,iendlu
!
! include
!
! internals
!
      integer i,j,k,l,jstrt,jstop,nja
      integer izero
      double precision one
      parameter(izero=0,one=1.0d0)
!
! start of ds_eye_f90_mod
!
!  -- test/set max_r and max_c
!
      nja=ia(n+1)-1
      if(idistc.eq.1) then
!
!  -- search the matrix rows
!  -- not necessary if appropriate pointers are passed from
!  -- the matrix stored in a triangle
!  -- the input matrix in ia/ja/a should be partially ordered
!
        if(ia(n+1)-1+n*lsize.ge.max_c-1) then
          max_c=2*nja+n*lsize
          deallocate(ac)
          allocate(ac(max_c),stat=ierr)
          if(ierr.ne.0) call serr(0,2,'sparslab','ds_eye_f90_mod', &
            ' missing space to store the preconditioner',1603,2)
          deallocate(jc)
          allocate(jc(max_c),stat=ierr)
          if(ierr.ne.0) call serr(0,2,'sparslab','ds_eye_f90_mod', &
            ' missing space to store the preconditioner',1603,2)
        end if
      end if
      if(idistr.eq.1) then
!
!  -- search the matrix rows
!  -- not necessary if appropriate pointers are passed from
!  -- the matrix stored in a triangle
!  -- the input matrix in ia/ja/a should be partially ordered
!
        if(ia(m+1)-1+n*lsize.ge.max_r-1) then
          max_r=2*nja+n*lsize
          deallocate(jr)
          allocate(jr(max_r),stat=ierr)
          if(ierr.ne.0) call serr(0,2,'sparslab','ds_eye_f90_mod', &
            ' missing space to store the preconditioner',1603,2)
        end if
      end if
!
!  -- clear vectors for row and column indices
!
      call iwset(max_r-1,izero,jr,1)
      jr(max_r)=1
      call iwset(max_c-1,izero,jc,1)
      jc(max_c)=1
!
!  -- set column pointers
!  -- and insert an unit matrix stored by columns
!
      if(idistc.eq.0.or.idistc.eq.2) then
        if(idistc.eq.0) then
          len=1
          iendlu=len*(m-1)+1
        elseif(idistc.eq.2) then
          i=max_c/3
          len=max(1,i/m)
          iendlu=len*(m-1)+1
        end if
!
!    -- set initial values in the distance len
!
        k=1
        do i=1,n
          ic(i)=k
          kc(i)=1
          jc(k)=i
          ac(k)=one
          k=k+len
        end do
      elseif(idistc.eq.1) then
        k=1
        do i=1,n
          jstrt=ia(i)
          jstop=ia(i+1)-1
          len=jstop-jstrt+1
          do j=jstrt,jstop
            l=ja(j)
            if(l.eq.i) then
              len=j-jstrt+1
              exit
            end if
          end do
          ic(i)=k
          kc(i)=1
          jc(k)=i
          ac(k)=one
          k=k+len+lsize
        end do
        iendlu=k-len-lsize
      end if
      if(iendlu.ge.max_c-1) then
        stop 'internal error'
      end if
!
!  -- set row pointers
!  -- and insert row structure of the unit matrix
!
      if(idistr.eq.0.or.idistr.eq.2) then
        if(idistr.eq.0) then
          len=1
          iendru=len*(m-1)+1
        elseif(idistr.eq.2) then
          i=max_r/3
          len=max(1,i/m)
          iendru=len*(m-1)+1
        end if
!
!    -- set initial values
!
        k=1
        do i=1,m
          ir(i)=k
          kr(i)=1
          jr(k)=i
          k=k+len
        end do
      elseif(idistr.eq.1) then
        k=1
        do i=1,m
          jstrt=ia(i)
          jstop=ia(i+1)-1
          len=jstop-jstrt+1
          do j=jstrt,jstop
            l=ja(j)
            if(l.eq.i) then
              len=jstop-j+1
              exit
            end if
          end do
          ir(i)=k
          kr(i)=1
          jr(k)=i
          k=k+len+lsize
        end do
        iendru=k-len-lsize
      end if
      if(iendru.ge.max_r-1) then
        stop 'internal error'
      end if
!
!  -- return
!
      return
!
! end of ds_eye_f90_mod
!
      end subroutine ds_eye_f90_mod


! (c) sparslab module name=ds_eye_mod
!
! purpose:
!   initialization of dynamic data structures for right-looking
!   ainv preconditioner.
!   input matrix is in csr format.
!
! history:
!   original version for sparslab - tu - 13/04/1996.
!
! parameters:
!  ii  n  number of input matrix columns.
!  ii  m  number of input matrix rows.
!  gi  ia(n+1)/ja(ia(nn+1)-1) input matrix graph.
!  mo  ic(n)/jc(ic(n)+kc(n)-1)/kc(n)/ac(ic(n)+kc(n)-1) output unit
!        matrix in dsc format.
!  ii  max_c  size of the vectors jc/ac.
!  mo  ir(n)/jr(ir(n)+kr(n)-1)/kr(n) output graph of unit matrix
!        in dsr format.
!  ii  max_r  size of the vector jr.
!  io  iendru  position of last entry in ir/jr/kr.
!  io  iendlu  position of last entry in ic/jc/kc/ac.
!  ii  idistr  type of the distribution pattern of the dsc format.
!  ii  idistc  type of the distribution pattern of the dsr format.
!  ii  lsize  size of the distance between entries in ds* formats.
!
      subroutine ds_eye_mod(n,m,ia,ja,ic,jc,kc,ac,max_c,ir,jr,kr,max_r, &
        iendru,iendlu,idistr,idistc,lsize,ierr)
!
! parameters
!
      integer n,m,max_r,max_c,lsize,ierr
      integer idistr,idistc,len
      integer :: ia(*),ja(*)
      integer, allocatable :: ir(:),jr(:),kr(:),ic(:),jc(:),kc(:)
      double precision, allocatable :: ac(:)
      integer iendru,iendlu
!
! include
!
! internals
!
      integer i,j,k,l,jstrt,jstop,nja
      integer izero
      double precision one
      parameter(izero=0,one=1.0d0)
!
! start of ds_eye_mod
!
!  -- test/set max_r and max_c
!
      nja=ia(n+1)-1
      len=1
      if(idistc.eq.1) then
!
!  -- search the matrix rows
!  -- not necessary if appropriate pointers are passed from
!  -- the matrix stored in a triangle
!  -- the input matrix in ia/ja/a should be partially ordered
!
        if(ia(n+1)-1+n*lsize.ge.max_c-1) then
          max_c=2*nja+n*lsize
          deallocate(ac)
          allocate(ac(max_c),stat=ierr)
          if(ierr.ne.0) call serr(0,2,'sparslab','ds_eye_mod', &
            ' missing space to store the preconditioner',1603,2)
          deallocate(jc)
          allocate(jc(max_c),stat=ierr)
          if(ierr.ne.0) call serr(0,2,'sparslab','ds_eye_mod', &
            ' missing space to store the preconditioner',1603,2)
        end if
      end if
      if(idistr.eq.1) then
!
!  -- search the matrix rows
!  -- not necessary if appropriate pointers are passed from
!  -- the matrix stored in a triangle
!  -- the input matrix in ia/ja/a should be partially ordered
!
        if(ia(m+1)-1+n*lsize.ge.max_r-1) then
          max_r=2*nja+n*lsize
          deallocate(jr)
          allocate(jr(max_r),stat=ierr)
          if(ierr.ne.0) call serr(0,2,'sparslab','ds_eye_mod',  &
            ' missing space to store the preconditioner',1603,2)
        end if
      end if
!
!  -- clear vectors for row and column indices
!
      call iwset(max_r-1,izero,jr,1)
      jr(max_r)=1
      call iwset(max_c-1,izero,jc,1)
      jc(max_c)=1
!
!  -- set column pointers
!  -- and insert an unit matrix stored by columns
!
      if(idistc.eq.0.or.idistc.eq.2) then
        if(idistc.eq.0) then
          len=1
          iendlu=len*(m-1)+1
        elseif(idistc.eq.2) then
          i=max_c/3
          len=max(1,i/m)
          iendlu=len*(m-1)+1
        end if
!
!    -- set initial values in the distance len
!
        k=1
        do i=1,n
          ic(i)=k
          kc(i)=1
          jc(k)=i
          ac(k)=one
          k=k+len
        end do
      elseif(idistc.eq.1) then
        k=1
        do i=1,n
          jstrt=ia(i)
          jstop=ia(i+1)-1
          len=jstop-jstrt+1
          do j=jstrt,jstop
            l=ja(j)
            if(l.eq.i) then
              len=j-jstrt+1
              go to 130
            end if
          end do
 130 &
          continue
          ic(i)=k
          kc(i)=1
          jc(k)=i
          ac(k)=one
          k=k+len+lsize
        end do
        iendlu=k-len-lsize
      end if
      if(iendlu.ge.max_c-1) then
        stop 'internal error'
      end if
!
!  -- set row pointers
!  -- and insert row structure of the unit matrix
!
      if(idistr.eq.0.or.idistr.eq.2) then
        if(idistr.eq.0) then
          len=1
          iendru=len*(m-1)+1
        elseif(idistr.eq.2) then
          i=max_r/3
          len=max(1,i/m)
          iendru=len*(m-1)+1
        end if
!
!    -- set initial values
!
        k=1
        do i=1,m
          ir(i)=k
          kr(i)=1
          jr(k)=i
          k=k+len
        end do
      elseif(idistr.eq.1) then
        k=1
        do i=1,m
          jstrt=ia(i)
          jstop=ia(i+1)-1
          len=jstop-jstrt+1
          do j=jstrt,jstop
            l=ja(j)
            if(l.eq.i) then
              len=jstop-j+1
              exit
            end if
          end do
          ir(i)=k
          kr(i)=1
          jr(k)=i
          k=k+len+lsize
        end do
        iendru=k-len-lsize
      end if
      if(iendru.ge.max_r-1) then
        stop 'internal error'
      end if
!
!  -- return
!
      return
!
! end of ds_eye_mod
!
      end subroutine ds_eye_mod



! (c) sparslab module name=csr2dsc_mod
!
! purpose:
!  matrix conversion from csr format
!  into dsc format with sufficient elbow space.
!
! history:
!   original version for sparslab - tu - 04/05/2001.
!
! parameters:
!   ii  n  matrix dimension.
!   oi  ia(n+1)/ja(ia(n+1)-1)/aa(ia(n+1)-1) input matrix in cs format.
!   oo  ib(n+1)/jb(ib(n+1)-1)/kb(ib(n+1)-1)/ab(ib(n+1)-1)
!         output matrix in ds format.
!
      subroutine csr2dsc_mod(n,ia,ja,aa, &
        ic,jc,kc,ac,max_c,ir,jr,kr,max_r, &
        iendru,iendlu,lsize,ierr)
!
! parameters
!
      implicit none
      integer n,max_r,max_c,lsize,ierr
      integer ia(*),ja(*)
      double precision aa(*)
      integer, allocatable :: ir(:),jr(:),kr(:),ic(:),jc(:),kc(:)
      double precision, allocatable :: ac(:)
      integer iendru,iendlu
!
! interfaces
!
!
! internals
!
      integer, allocatable, dimension(:) :: wn01
      integer i,j,k,l,jstrt,jstop,max_r_org,max_c_org,jj
      integer izero,newmax_r,newmax_c,istrt,istop,itemp,incr,incc
      integer ind
      double precision one
      parameter(izero=0,one=1.0d0)
!
! start of csr2dsc
!
!  -- allocation
!
      allocate(wn01(n+1),stat=ierr)
      if(ierr.ne.0) call serr(0,2,'sparslab','cs2ds2', &
        ' allocation error',8,2)
!
!  -- check max_r and max_c with respect to embedding of the
!  -- input matrix
!
      max_r_org=max_r
      max_c_org=max_c
      itemp=3*ia(n+1)-1
      max_r=max(max_r,itemp)
      max_c=max(max_c,itemp)
!
!  -- second check with respect to lsize
!
      max_r=max(max_r,ia(n+1)-1+n*lsize+1)
      max_c=max(max_c,ia(n+1)-1+n*lsize+1)
!
!  -- check for reallocation
!
      if(max_r_org.lt.max_r) then
!        call getincr(n,1,0,incr)
        incr=min(max_r,incr)
        incr=max(max_r-max_r_org,incr)
        if(incr.gt.0) then
          call realli_a(jr,max_r_org,incr,newmax_r,ierr)
          max_r=newmax_r
        end if
      end if
      if(max_c_org.lt.max_c) then
!        call getincr(n,1,0,incc)
        incc=min(max_r,incc)
        incc=max(max_c-max_c_org,incc)
        if(incc.gt.0) then
          call realli_a(jc,max_c_org,incc,newmax_c,ierr)
          call reallr_a(ac,max_c_org,incc,newmax_c,ierr)
          max_c=newmax_c
        end if
      end if
!
!  -- clear vectors for row and column indices
!
      call iwset(max_r-1,izero,jr,1)
      jr(max_r)=1
      call iwset(max_c-1,izero,jc,1)
      jc(max_c)=1
!
!  -- set row pointers
!
      k=1
      ind=0
      ir(1)=1
      do i=1,n
        jstrt=ia(i)
        jstop=ia(i+1)-1
        do j=jstrt,jstop
          l=ja(j)
          ind=ind+1
          jr(ind)=l
        end do
        kr(i)=jstop-jstrt+1
        ir(i+1)=ind+lsize
        ind=ind+lsize-1
      end do
      iendru=ir(n+1)-1
!
!  -- set column pointers (assumed ordering of matrix indices)
!  -- this is something like direct transposition of the input
!  -- matrix into dsc format.
!
      k=1
      ind=0
      ic(1)=1
      call iwset(n,0,wn01,1)
      call iwset(n,0,kc,1)
!
!  -- compute counts of rows
!
      jstrt=1
      do i=2,n+1
        jstop=ia(i)
        do j=jstrt,jstop-1
          jj=ja(j)
          wn01(jj)=wn01(jj)+1
        end do
        jstrt=jstop
      end do
!
!  -- get column pointers
!
      istrt=1
      ic(1)=istrt
      do j=1,n
        istop=istrt+wn01(j)
        ic(j+1)=istop+lsize
        wn01(j)=istrt
        istrt=istop+lsize
      end do
!
!  -- move the data
!
      do i=1,n
        jstrt=ia(i)
        jstop=ia(i+1)-1
        do j=jstrt,jstop
          jj=ja(j)
          k=wn01(jj)
          jc(k)=i
          ac(k)=aa(j)
          wn01(jj)=wn01(jj)+1
          kc(jj)=kc(jj)+1
        end do
      end do
      iendlu=ic(n+1)-1
!
!  -- deallocation
!
      deallocate(wn01)
!
!  -- return
!
      return
!
! end of csr2dsc_mod
!
      end subroutine csr2dsc_mod



! (c) sparslab module name=csr2sc3_mod
!
! purpose:
!  matrix conversion from csr format
!  into dsc format with no sufficient elbow space.
!  lengths of rows are not set up.
!
! history:
!   original version for sparslab - tu - 09/11/1996.
!
! parameters:
!
      subroutine csr2dsc3_mod(n,ia,ja,ic,jc,ac,max_c,ir,jr,max_r,info)
!
! parameters
!
      integer n,max_c,max_r,info
      integer :: ia(*),ja(*)
      integer, allocatable, dimension(:) :: ir,jr,ic,jc
      double precision, allocatable, dimension(:) :: ac
!
!
! internals
!
      integer, allocatable, dimension(:) :: wn01
      integer i,j,k,l,jstrt,jstop,incr,incc,newmax_r,newmax_c,itemp
      integer max_c_org,max_r_org,ierr
      double precision zero,one
      parameter(zero=0.0d0,one=1.0d0)
!
! start of csr2sc3_mod
!
!  -- allocation
!
      allocate(wn01(n+1),stat=ierr)
      if(ierr.ne.0) go to 400
!
!  -- check max_r and max_c with respect to embedding of the
!  -- input matrix
!
      max_r_org=max_r
      max_c_org=max_c
      itemp=ia(n+1)
      max_r=itemp
      max_c=itemp
!
!  -- check for reallocation
!
      if(max_r_org.lt.max_r) then
        incr=max_r-max_r_org
        call realli_a(jr,max_r,incr,newmax_r,ierr)
        max_r=newmax_r
      end if
      if(max_c_org.lt.max_c) then
        incc=max_c-max_c_org
        call realli_a(jc,max_c,incc,newmax_c,ierr)
        call reallr_a(ac,max_c,incc,newmax_c,ierr)
        max_c=newmax_c
      end if
!
! initialization
!
      call iwset(n,0,wn01,1)
      call dinit(max_c,zero,ac,1)
!
!  -- set up row pointers
!  -- and insert row structure of the upper triangle of the original matrix
!
      k=1
      do i=1,n
        ir(i)=k
        jstrt=ia(i)
        jstop=ia(i+1)-1
        do j=jstrt,jstop
          l=ja(j)
          if(l.ge.i) then
            wn01(l)=wn01(l)+1
            jr(k)=l
            k=k+1
          end if
        end do
      end do
!
!  -- set up column data structure
!
      ic(1)=1
      k=1
      do i=1,n
        ic(i+1)=k+wn01(i)
        k=ic(i+1)
      end do
      do i=1,n
        k=ic(i)
        ac(k)=one
        wn01(i)=k+1
      end do
!
      do i=1,n
        jstrt=ia(i)
        jstop=ia(i+1)-1
        do j=jstrt,jstop
          l=ja(j)
          if(l.eq.i) then
            k=ic(i)
            jc(k)=l
          elseif(l.gt.i) then
            k=wn01(l)
            jc(k)=i
            wn01(l)=k+1
          end if
        end do
      end do
!
!  -- deallocation
!
      deallocate(wn01)
!
!  -- return
!
      return
!
 400  continue
      info=8
      return
!
! end csr2sc3_mod
!
      end subroutine csr2dsc3_mod


!
      end module matrix90



      module ptools_mod
!
      use system_mod
!
      contains
!
!


! (c) sparslab module name=aicol
! purpose:
!   modify a pivot for sparse approximate inverse preconditioner ainv,
!   invert dv1
!   get a column vector wn03/wr03(1..ind3) and scale
!   a row vector wn02/wr02(1..ind2) by dv1.
!   these operations correspond to initialization
!   before sparse rank-1 update in each step
!   of the approximate inverse preconditioner procedure
!   if diag_one=1 then scale column z_i by sqrt(pivot_i)
!
! history:
!   original version for sparslab - tu - 12/04/1996.
!
! parameters:
!
      subroutine aicol(ptc,lenc,cnc,h,wn03,wr03,ind3, &
        wr02,ind2,indexc,dv1,diagtol,imodif,diag_one)
!
! parameters
!
      implicit none
      integer :: ptc(*),lenc(*),cnc(*)
      double precision :: h(*)
      integer wn03(*)
      double precision wr02(*),wr03(*)
      double precision dv1,diagtol
      integer, intent(inout) :: ind2
      integer :: ind3,indexc,imodif
      integer diag_one
!
! internals
!
      integer istrt,istop,i
      double precision zero,temp,one
      logical never
      parameter(zero=0.0d0,one=1.0d0,never=.false.)
!
! start of aicol
!
      istrt=ptc(indexc)
      istop=istrt+lenc(indexc)-1
!
!  -- test dv1 - if dv1 too small then modify
!  -- get vector wn03/wr03(1..ind3)
!
      ind3=0
      if(dv1.lt.diagtol) then
        imodif=imodif+1
        dv1=max(abs(dv1),diagtol)
      end if
      do i=istrt,istop
        ind3=ind3+1
        wn03(ind3)=cnc(i)
        wr03(ind3)=h(i)
      end do
!
!  -- invert dv1
!
      dv1=one/dv1
!
!  -- if diag_one is set then scale pivot column
!
      if(diag_one.eq.1) then
        ind3=0
        temp=sqrt(dv1)
        dv1=temp
        do i=istrt,istop
          ind3=ind3+1
          h(i)=h(i)*temp
          wr03(ind3)=h(i)
        end do
      end if
!
!  -- scale the vector wn02/wr02(1..ind2)
!
      do i=1,ind2
        wr02(i)=wr02(i)*dv1
      end do
!
!  -- return
!
      return
!
! end of aicol
!
      end subroutine aicol



!
      end module ptools_mod



      module rank1
!
      use system_mod
      use ptools_mod
      use matrix90
!
      contains
!
!


! (c) sparslab module name=rank1n_mod
!
! purpose:
!   sparse rank-one update in dynamic data structures.
!   it updates a submatrix given by row indices
!   wn03(1..ind3) and column indices wn02(1..ind2)
!   and removes pivot column indexk and row indexj
!   from the row data structures.
!   nonsymmetric version.
!
!   vector wn03/wr03(1..ind3) corresponds to a pivot column.
!   input matrix is stored in the dynamic data structures
!   cnr,ptr,lenr/cnc,ptc,lenc
!
! history:
!   original version for sparslab - tu - 01/05/2001.
!   based on the codes sig.f, nig.f, aig.f, ainvupd1.f
!
      subroutine rank1n_mod(scrlvl,n,m,ptr,cnr,lenr, &
        max_r,ptc,cnc,lenc,h,max_c, &
        indexk,wr01,wn03,wr03,ind3,wn02,wr02,ind2, &
        iendru,iendlu,drfl,nit,if2,idist,garcol,garrow,droptyp, &
        nreallocr,nreallocc)
!
! parameters
!
      implicit none
      integer n,m,droptyp,nreallocr,nreallocc,scrlvl
      integer nit,if2,max_r,max_c
      integer, allocatable :: ptr(:),cnr(:),lenr(:),ptc(:),cnc(:),lenc(:)
      double precision, allocatable :: h(:)
      integer iendru,iendlu,nrow,garrow,garcol,indexk,ind2,ind3
      integer idist
      integer wn02(*),wn03(*)
      double precision wr01(*),wr02(*),wr03(*),temp
      double precision drfl
!
! internals
!
      integer istrt,istop,ibeg,ncol,i1,ierr
      integer i,j,j1,j2,j3,iqcmpr,jstrt,jstop,incr
      integer ll1,k,len,newmax_r,newmax_c,oldmax_r,oldmax_c
      double precision zero,one,drfl_rel,avg_size
      parameter (zero=0.0d0,one=1.0d0)
!
!  -- start of rank1n_mod
!
!
!  -- define new parameters
!
      ibeg=1
!
!  -- remove indexk from the rows
!  -- which intersect column indexk.
!
      istrt=ptc(indexk)
      istop=istrt+lenc(indexk)-1
      do i=istrt,istop
        k=cnc(i)
        jstrt=ptr(k)
        jstop=jstrt+lenr(k)-1
        do j=jstrt,jstop
          if(cnr(j).eq.indexk) then
            cnr(j)=cnr(jstop)
            cnr(jstop)=0
            lenr(k)=lenr(k)-1
            go to 25
          end if
        end do
 25  &
        continue
      end do
!
!  -- main loop for columns with indices from wn02(1..ind2)
!
      do ll1=1,ind2
!
!    -- get index of the updated column and
!    -- corresponding column value of the rank-1 matrix
!
        ncol=wn02(ll1)
        temp=wr02(ll1)
!
!    -- scatter and scale the pivot column from wr03 into wr01
!
        do i=1,ind3
          j=wn03(i)
          wr01(j)=-wr03(i)*temp
        end do
!
!    -- define start and end of the column ncol
!
        istrt=ptc(ncol)
        istop=istrt+lenc(ncol)-1
!
!    -- compute average size of an original nonzero
!    -- for relative dropping
!
        if(droptyp .ne. 0) then
          avg_size=zero
          do j=istrt,istop
            temp=h(j)
            avg_size=avg_size+abs(temp)
          end do
          len=istop-istrt+1
          if(len.ne.0) then
            avg_size=avg_size/dble(len)
          end if
        end if
!
!    -- get drop tolerance
!
        if(droptyp .ne. 0) then
          drfl_rel=drfl*avg_size
        else
          drfl_rel=drfl
        end if
!
!    -- update existing entries of the column ncol
!
        do j=istrt,istop
          k=cnc(j)
          if(wr01(k).ne.zero) then
!
!        -- update
!
            h(j)=h(j)+wr01(k)
            wr01(k)=zero
            if(abs(h(j)).lt.drfl_rel.and.k.ne.ncol) then
!
!          -- mark the value which is to be dropped
!
              cnc(j)=0
!
!          -- define start and end of the corresponding row list
!
              jstrt=ptr(k)
              jstop=jstrt+lenr(k)-1
!
!          -- find index ncol in the row list corresponding
!          -- to an entry to be dropped
!
              do i1=jstrt,jstop
                if(cnr(i1).eq.ncol) then
!
!              -- index found
!
                  cnr(i1)=cnr(jstop)
                  cnr(jstop)=0
                  lenr(k)=lenr(k)-1
!
!              -- jump outside
!
                  go to 204
                end if
              end do
 204 &
              continue
            end if
          end if
        end do
!
! -- remove marked candidates to be dropped
! -- shrink remaining entries in the column ncol between
! -- istrt and istop
!
        i=istrt
        do j=istrt,istop
          if(cnc(j).eq.0) then
            if2=if2-1
            go to 220
          else
            cnc(i)=cnc(j)
            h(i)=h(j)
            i=i+1
          end if
 220 &
          continue
        end do
        lenc(ncol)=i-istrt
        do j=i,istop
          cnc(j)=0
        end do
        istop=i-1
!
!    -- insert fill-in into column ncol
!
        do 80 i=1,ind3
          nrow=wn03(i)
!
!      -- test fill-in size
!
          if(abs(wr01(nrow)).gt.drfl_rel) then
!
!        -- look for a free space at the beginning of a column list
!
            if(istrt.gt.1) then
              if(cnc(istrt-1).eq.0) then
!
!            -- add a the new entry at the beginning of the column list
!
                istrt=istrt-1
                cnc(istrt)=nrow
                h(istrt)=wr01(nrow)
                lenc(ncol)=lenc(ncol)+1
                ptc(ncol)=ptc(ncol)-1
                if2=if2+1
                go to 550
              end if
            endif
!
!        -- look for a free space at the end of a column list
!
 400 &
            continue
            if(cnc(istop+1).eq.0) then
!
!          -- add a new element at the end of a column list
!
              iqcmpr=0
              istop=istop+1
              cnc(istop)=nrow
              h(istop)=wr01(nrow)
              if2=if2+1
              iendlu=max(iendlu,istop)
              lenc(ncol)=lenc(ncol)+1
            else
              j1=istop-istrt+1
              if((iendlu+j1).lt.max_c-1) then
!
!            -- copy a column at the current end
!            -- of the column working space
!
                j2=istrt-1-iendlu
                do j=iendlu+1,iendlu+j1
                  j3=j2+j
                  cnc(j)=cnc(j3)
                  h(j)=h(j3)
                  cnc(j3)=0
                end do
                iqcmpr=0
                istrt=iendlu+1
                ptc(ncol)=istrt
                istop=iendlu+j1
                cnc(istop+1)=0
                go to 400
              else
!
!            -- garbage collection of the column working space
!
                if(iqcmpr.eq.1.or. &
                   (dble(iendlu)/dble(nit))*dble(n).gt.max_c) then
!
!              -- reallocation of cnc,h
!
                  oldmax_c=max_c
                  incr=min(max_c,int(0.5d0*(n*n-nit*(nit-1)/2)))
                  call realli_a(cnc,max_c,incr,newmax_c,ierr)
                  call reallr_a(h,max_c,incr,newmax_c,ierr)
                  max_c=newmax_c
                  nreallocc=nreallocc+1
                  call iwset1(max_c-oldmax_c+1,0,cnc,1,oldmax_c)
                  cnc(max_c)=1
                end if
                iqcmpr=1
                garcol=garcol+1
                if(scrlvl.gt.0) then
                  write(*,*) ' column garbage collection no.',garcol
                end if
                call garclds(n,ptc,cnc,lenc,h,max_c, &
                  ibeg,iendlu,nit,idist)
                istrt=ptc(ncol)
                istop=istrt+lenc(ncol)-1
                go to 400
              end if
            end if
 550 &
            continue
!
!        -- add a new index ncol into a row list corresponding to
!        -- the new fill-in position nrow
!
            jstrt=ptr(nrow)
            jstop=jstrt+lenr(nrow)-1
!
!        -- look for a free space at the beginning of a row list
!
            if(jstrt.gt.1) then
              if(cnr(jstrt-1).eq.0) then
!
!            -- add a new element at the beginning of a row list
!
                jstrt=jstrt-1
                cnr(jstrt)=ncol
                lenr(nrow)=lenr(nrow)+1
                ptr(nrow)=ptr(nrow)-1
                go to 450
              end if
            endif
!
!          -- look for a free space at the end of a row list
!
 440 &
            continue
            if(cnr(jstop+1).eq.0) then
!
!          -- add a new element at the end of a row list
!
              iqcmpr=0
              jstop=jstop+1
              cnr(jstop)=ncol
              iendru=max(iendru,jstop)
              lenr(nrow)=lenr(nrow)+1
            else
!
!          -- copy a row at the current end of the row working space
!
              j1=jstop-jstrt+1
              i1=jstrt-1-iendru
              if((iendru+j1).lt.max_r-1) then
                do j2=1+iendru,j1+iendru
                  j3=i1+j2
                  cnr(j2)=cnr(j3)
                  cnr(j3)=0
                end do
                iqcmpr=0
                jstrt=iendru+1
                ptr(nrow)=jstrt
                jstop=iendru+j1
                cnr(jstop+1)=0
                go to 440
              else
!
!            -- garbage collection of the row working space
!
                if(iqcmpr.eq.1.or. &
                   (dble(iendru)/dble(nit))*dble(n).gt.max_r) then
!
!              -- reallocation of cnr
!
                  oldmax_r=max_r
                  incr=min(max_r,int(0.5d0*(n*n-nit*(nit-1)/2)))
                  call realli_a(cnr,max_r,incr,newmax_r,ierr)
                  max_r=newmax_r
                  nreallocr=nreallocr+1
                  call iwset1(max_r-oldmax_r+1,0,cnr,1,oldmax_r)
                  cnr(max_r)=1
                end if
                iqcmpr=1
                garrow=garrow+1
                if(scrlvl.gt.0) then
                  write(*,*) ' row garbage collection no.',garrow
                end if
                call garclds2(m,ptr,cnr,lenr,max_r,ibeg, &
                  iendru,idist)
                jstrt=ptr(nrow)
                jstop=jstrt+lenr(nrow)-1
                go to 440
              end if
            end if
 450 &
            continue
          end if
!
!      -- clear nrow position in wr01
!
          wr01(nrow)=zero
!
!      -- end of fill-in cycle
!
 80  &
        continue
!
!   -- end of loop for columns
!
      end do
!
!  -- return
!
      return
!
! end of rank1n_mod
!
      end subroutine rank1n_mod



!
      end module rank1



      module ainv90
!
      use system_mod
      use ptools_mod
      use matrix90
      use rank1
!
      contains
!
!

			
! (c) sparslab module name=nbif_interleave_experiments_2008
!
! purpose:
!   compute incomplete factorization based on the approximate
!   inverse computation based on the Sherman-Morrison formula.
!   derived from smic. it will assemble v_s for check.
!   then it will be made efficient.
!
! history:
!   modified from bif - tu - 20/04/2008.
!
! parameters:
!  ii n  matrix dimension
!  oi ia,ja,aa  matrix A in  CSR format (or A^T in CSC format)
!  oo il,jl,al  incomplete Cholesky factor
!  iu max_u  initial size of U
!  iu max_v  initial size of V
!  io  imodif  number of modified pivots
!  io  fillu,fillv  sizes of U, V
!
!
      subroutine nbif_interleave_experiments_2008  &
        (outlvl,ounit,n,ia,ja,aa,                  &
        iat,jat,aat,il,jl,al,ilt,jlt,alt,max_u,max_v,  &
        max_ut,max_vt,max_l,max_lt,                    &
        s,anorm,drflu,drflv,lsize,imodif,imodift,fillu,fillv, &
        fillut,fillvt,filll,filllt,                           &
        drfll,drfllt,info)
!
! parameters
!
      implicit none
      integer n,max_u,max_v,max_l,max_lt,imodif,imodift,fillu,fillv
      integer max_ut,max_vt,fillut,fillvt
      integer lsize,filll,filllt
      integer outlvl,ounit,info
      integer ia(*),ja(*)
      integer iat(*),jat(*)
      integer, allocatable, dimension(:) :: il,jl
      double precision, allocatable, dimension(:) :: al
      integer, allocatable, dimension(:) :: ilt,jlt
      double precision, allocatable, dimension(:) :: alt
      double precision aa(*),aat(*),s,drflu,drflv,drfll,drfllt
      double precision anorm
!
! internals
!
      integer, allocatable, dimension(:) :: wnju,wnjuf
      integer, allocatable, dimension(:) :: wnjv,wnjvf
      double precision, allocatable, dimension(:) :: wrau,wrav
      integer, allocatable, dimension(:) :: wn01
      double precision, allocatable, dimension(:) :: y,diag
      integer, allocatable, dimension(:) :: iu,ju,iv,jv
      double precision, allocatable, dimension(:) :: av,au
      double precision, allocatable, dimension(:) :: norm_invl,norm_l
      integer, allocatable, dimension(:) :: wnjut,wnjuft
      integer, allocatable, dimension(:) :: wnjvt,wnjvft
      double precision, allocatable, dimension(:) :: wraut,wravt
      integer, allocatable, dimension(:) :: wn01t
      double precision, allocatable, dimension(:) :: yt,diagt
      integer, allocatable, dimension(:) :: iut,jut,ivt,jvt
      double precision, allocatable, dimension(:) :: avt,aut
      double precision, allocatable, dimension(:) :: norm_invlt,norm_lt
!
      integer indrow,indold,needed
      integer incr,newmax_u,newmax_v,newmax_l
      integer, allocatable, dimension(:) :: urow_ia,urow_ja
      integer, allocatable, dimension(:) :: urow_last
      double precision, allocatable, dimension(:) :: urow_aa
      integer, allocatable, dimension(:) :: vrow_ia,vrow_ja
      integer, allocatable, dimension(:) :: vrow_last
      double precision, allocatable, dimension(:) :: vrow_aa
      integer realloc,nreallocu,nreallocv,nreallocl
      integer indrowt,indoldt,neededt,icount,lsiz2
      integer newmax_ut,newmax_vt,newmax_lt
      integer, allocatable, dimension(:) :: utrow_ia,utrow_ja
      integer, allocatable, dimension(:) :: utrow_last
      double precision, allocatable, dimension(:) :: utrow_aa
      integer, allocatable, dimension(:) :: vtrow_ia,vtrow_ja
      integer, allocatable, dimension(:) :: vtrow_last
      double precision, allocatable, dimension(:) :: vtrow_aa
      integer realloct,nreallocut,nreallocvt,nrealloclt
!
      integer ii,jstrt,jstop,ierr,iendl,iendlt
      integer i,j,k,kk,l,n1,indu,indut,indv,indvt,istrt,istop
      integer iendu,iendv,iendut,iendvt,ind,indt,jstr,no_updates
      integer no_major_updates,no_minor_updates
      double precision temp,temp2,diagtol,pivot,pivott
      double precision eps,zero,one,temp3
      double precision norm_l_max,norm_invl_max,drflv_dot
      double precision drflv_update,update_unsymmetry,ten
      double precision drflv_standard,tempmax,coef
      parameter (eps=2.2d-16,zero=0.0d0,one=1.0d0,ten=10.0d0)
      integer idamin
      logical missed,always
!
! start of nbif_interleave_experiments_2008
!
      always=.true.
      info=0
!
!     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!  -- block of drop tolerances for appropriate
!  -- mixture of factors and their inverses
!     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!  -- compatibility shift
!
      drfll=drfll+eps
      drfllt=drfllt+eps
!
!  -- initialization of derived drop tolerances
!
      drflv_dot=ten*drflv
      drflv_update=zero
!
!  -- ``standard'' drop tolerance (0.1)
!  -- safeguarded for zero input
!
      drflv_standard=one/ten
      if(drflv.eq.zero) drflv_standard=zero
!
      coef=0.9d0
      update_unsymmetry=ten
      no_updates=0
      no_major_updates=0
      norm_l_max=zero
      norm_invl_max=zero
      lsiz2=max(1,lsize/2)
!
!  -- allocate reallocatables
!
      realloc=1
      realloct=1
      max_u=max(n,max_u)
      max_v=max(n,max_v)
      max_l=max(n,max_l)
      max_ut=max(n,max_ut)
      max_vt=max(n,max_vt)
      max_lt=max(n,max_lt)
      allocate(norm_invl(n),norm_l(n),stat=ierr)
      if(ierr.ne.0) go to 400
      allocate(iu(n+1),ju(max_u),au(max_u),stat=ierr)
      if(ierr.ne.0) go to 400
      allocate(iv(n+1),jv(max_v),av(max_v),stat=ierr)
      if(ierr.ne.0) go to 400
      allocate(norm_invlt(n),norm_lt(n),stat=ierr)
      if(ierr.ne.0) go to 400
      allocate(iut(n+1),jut(max_ut),aut(max_ut),stat=ierr)
      if(ierr.ne.0) go to 400
      allocate(ivt(n+1),jvt(max_vt),avt(max_vt),stat=ierr)
      if(ierr.ne.0) go to 400
!
!  -- allocate memory
!
      n1=n+1
      allocate(wnju(n1),wnjuf(n1),wrau(n1))
      allocate(wnjv(n1),wnjvf(n1),wrav(n1))
      allocate(wn01(n1),y(n),diag(n))
      allocate(wnjut(n1),wnjuft(n1),wraut(n1))
      allocate(wnjvt(n1),wnjvft(n1),wravt(n1))
      allocate(wn01t(n1),yt(n),diagt(n))
!
!  -- allocate the rest
!
      allocate(urow_ia(n),urow_ja(n*lsize),urow_aa(n*lsize))
      allocate(vrow_ia(n),vrow_ja(n*lsize),vrow_aa(n*lsize))
      allocate(urow_last(n),vrow_last(n))
      allocate(utrow_ia(n),utrow_ja(n*lsize),utrow_aa(n*lsize))
      allocate(vtrow_ia(n),vtrow_ja(n*lsize),vtrow_aa(n*lsize))
      allocate(utrow_last(n),vtrow_last(n))
!
!  -- echo
!
!     Initialization
!
      diagtol=eps
      imodif=0
      imodift=0
      iu(1)=1
      iv(1)=1
      iut(1)=1
      ivt(1)=1
!
!  -- initialize auxiliary vectors
!
      call iwset(n,n1,wnjuf,1)
      call iwset(n,n1,wnjvf,1)
      call iwset(n,n1,wn01,1)
      call iwset(n,n1,wnjuft,1)
      call iwset(n,n1,wnjvft,1)
      call iwset(n,n1,wn01t,1)
!
      wrau(n1)=zero
      wrav(n1)=zero
      wraut(n1)=zero
      wravt(n1)=zero
!
      do i=1,n
        norm_l(i)=zero
        norm_lt(i)=zero
      end do

!
!     Set up indexes to copy columns into U and V
      iendu=0
      iendv=0
      iendut=0
      iendvt=0
!
!  -- initialize urow
!
      ind=1
      do i=1,n
        urow_ia(i)=ind
        urow_last(i)=ind-1
        vrow_ia(i)=ind
        vrow_last(i)=ind-1
        ind=ind+lsize
      end do
!
!  -- initialize utrow
!
      indt=1
      do i=1,n
        utrow_ia(i)=indt
        utrow_last(i)=indt-1
        vtrow_ia(i)=indt
        vtrow_last(i)=indt-1
        indt=indt+lsize
      end do
!
      do k=1,n
!
!    -- initialization
!
!       Vector v_k=y_k=A(:,k)-s*e_k
!
        istrt=ia(k)
        istop=ia(k+1) -1
        indv=0
        tempmax=zero
        do i=istrt,istop
          j=ja(i)
          if(j.ge.k) then
            indv=indv+1
            wnjv(indv)=j
            wrav(indv)=aa(i)
            y(indv)=aa(i)
            wnjvf(j)=indv
           else
             tempmax=max(tempmax,abs(aa(i)))
           end if
         end do
         do i=istrt,istop
          j=ja(i)
!
!      -- additional filtration
!
          if(j.lt.k.and.abs(aa(i)).ge.coef*tempmax.or. &
            j.lt.k.and.j.ge.k-10) then
            indv=indv+1
            wnjv(indv)=j
            wrav(indv)=aa(i)
            y(indv)=aa(i)
            wnjvf(j)=indv
          end if
        end do
        j=wnjvf(k)
        if(j.eq.n1) stop ' internal error'
        wrav(j)=wrav(j)-s
        y(j)=wrav(j)
        wrav(n1)=zero
!
!    -- initialization
!
!       Vector vt_k=yt_k=At(:,k)-s*e_k
!
        istrt=iat(k)
        istop=iat(k+1) -1
        indvt=0
        tempmax=zero
        do i=istrt,istop
          j=jat(i)
          if(j.ge.k) then
            indvt=indvt+1
            wnjvt(indvt)=j
            wravt(indvt)=aat(i)
            yt(indvt)=aat(i)
            wnjvft(j)=indvt
           else
             tempmax=max(tempmax,abs(aa(i)))
           end if
        end do
        do i=istrt,istop
          j=jat(i)
          if(j.lt.k.and.abs(aat(i)).ge.coef*tempmax.or. &
            j.lt.k.and.j.ge.k-10) then
            indvt=indvt +1
            wnjvt(indvt)=j
            wravt(indvt)=aat(i)
            yt(indvt)=aat(i)
            wnjvft(j)=indvt
          end if
        end do
        j=wnjvft(k)
        if(j.eq.n1) stop ' internal error'
        wravt(j)=wravt(j)-s
        yt(j)=wravt(j)
        wravt(n1)=zero
!
!    -- find indices i for which y_k^T*u_i \neq 0
!    -- wnju used as an auxiliary array
!
        indrow=0
        do i=1,indv
          j=wnjv(i)
!
!       -- dropping must be with respect to a standard drop
!       -- tolerance in order to skip updates if the inverse
!       -- gets to grow significantly
!
          if(j.ge.k.or.abs(y(i)).ge.drflv_standard) then
          jstrt=urow_ia(j)
          jstop=urow_last(j)
          do kk=jstrt,jstop
            ii=urow_ja(kk)
            if(wn01(ii).eq.n1) then
              indrow=indrow+1
              wn01(ii)=indrow
              wnju(indrow)=ii
            end if
          end do
          end if
        end do
        do i=1,indrow
          ii=wnju(i)
          wn01(ii)=n1
        end do
        do i=1,indv
          j=wnjv(i)
          wn01(j)=i
        end do
!
!    -- sparse SAXPY update for vector v_k:
!       V_{k}=Y_{k}-sum_{kk=1}^{k-1}[ (Y_{k}^{T}U_{kk})/(sr_kk) V_kk]
!
!     -- compute y_{k}^{t}*u_{kk}/s
!
        no_minor_updates=indrow
        do kk=1,indrow
          no_major_updates=no_major_updates+1
          ii=wnju(kk)
          istrt=iu(ii)
          istop=iu(ii+1)-1
          temp=zero
          do i=istrt,istop
            j=ju(i)
            l=wn01(j)
            if (l.ne.n1) then
              temp=temp+y(l)*au(i)
            end if
          end do
          temp=temp/s
          if(abs(temp).ge.zero*drflv_update) then
          no_updates=no_updates+1
!
!     --  substract, compute and add fill-in
!
          istrt=iv(ii)
          istop=iv(ii+1) -1
          if (temp.ne.zero) then
            do i=istrt,istop
              j=jv(i)
              l=wnjvf(j)
              if(l .ne. n1) then
                wrav(l)=wrav(l)-temp*av(i)
              else
                indv=indv +1
                wrav(indv)=-temp * av(i)
                wnjv(indv)=j
                wnjvf(j)=indv
              end if
            end do
          end if
        end if
        end do
!
!    -- reinitialize wn01
!
        istrt=ia(k)
        istop=ia(k+1) -1
        do i=istrt,istop
          j=ja(i)
          wn01(j)=n1
        end do
!
!    -- find indices i for which yt_k^T*ut_i \neq 0
!    -- wnjut used as an auxiliary array
!
        indrowt=0
        do i=1,indvt
          j=wnjvt(i)
          if(j.ge.k.or.abs(yt(i)).ge.drflv_standard) then
          jstrt=utrow_ia(j)
          jstop=utrow_last(j)
          do kk=jstrt,jstop
            ii=utrow_ja(kk)
            if(wn01t(ii).eq.n1) then
              indrowt=indrowt+1
              wn01t(ii)=indrowt
              wnjut(indrowt)=ii
            end if
          end do
          end if
        end do
        do i=1,indrowt
          ii=wnjut(i)
          wn01t(ii)=n1
        end do
        do i=1,indvt
          j=wnjvt(i)
          wn01t(j)=i
        end do
!
!    -- sparse SAXPY update for vector v_k:
!       Vt_{k}=Y_{k}-sum_{kk=1}^{k-1}[ (Y_{k}^{T}U_{kk})/(sr_kk) V_kk]
!
!     -- compute yt_{k}^{t}*u_{kk}/s
!
        no_minor_updates=no_minor_updates+indrowt
        do kk=1,indrowt
          no_major_updates=no_major_updates+1
          ii=wnjut(kk)
          istrt=iut(ii)
          istop=iut(ii+1)-1
          temp=zero
          do i=istrt,istop
            j=jut(i)
            l=wn01t(j)
            if (l.ne.n1) then
              temp=temp+yt(l)*aut(i)
            end if
          end do
          temp=temp/s
          if(abs(temp).ge.zero*drflv_update) then
          no_updates=no_updates+1
!
!     --  substract, compute and add fill-in
!
          istrt=ivt(ii)
          istop=ivt(ii+1) -1
          if (temp.ne.zero) then
            do i=istrt,istop
              j=jvt(i)
              l=wnjvft(j)
              if(l .ne. n1) then
                wravt(l)=wravt(l)-temp*avt(i)
              else
                indvt=indvt +1
                wravt(indvt)=-temp * avt(i)
                wnjvt(indvt)=j
                wnjvft(j)=indvt
              end if
            end do
          end if
          end if
        end do
!
!    -- reinitialize wn01
!
        istrt=iat(k)
        istop=iat(k+1) -1
        do i=istrt,istop
          j=jat(i)
          wn01t(j)=n1
        end do
!
!    -- here we have a column v_k ready
!    -- get its norm (before dropping):
!
        temp2=zero
        do i=1,indv
          j=wnjv(i)
          if(j.lt.k) then
            temp2=temp2+wrav(i)*wrav(i)
          elseif(j.eq.k) then
            temp2=temp2+s*s
          end if
        end do
        norm_invl(k)=dsqrt(temp2)/s
        missed=.false.
        do i=1,indv
          j=wnjv(i)
          if(j.gt.k) then
            missed=.true.
          elseif(j.eq.k) then
            temp3=one/(wrav(i)+s)
            temp3=temp3*temp3
            go to 450
          end if
        end do
 450 &
        continue
        if(missed) then
          jstr=1
        else
          jstr=i
        end if
        do i=jstr,indv
          j=wnjv(i)
          if(j.gt.k) then
            norm_l(j)=norm_l(j)+wrav(i)*temp3*wrav(i)
          end if
        end do
!
!    -- here we have a column vt_k ready
!    -- get its norm (before dropping):
!
        temp2=zero
        do i=1,indvt
          j=wnjvt(i)
          if(j.lt.k) then
            temp2=temp2+wravt(i)*wravt(i)
          elseif(j.eq.k) then
            temp2=temp2+s*s
          end if
        end do
        norm_invlt(k)=dsqrt(temp2)/s
        missed=.false.
        do i=1,indvt
          j=wnjvt(i)
          if(j.gt.k) then
            missed=.true.
          elseif(j.eq.k) then
            temp3=one/(wravt(i)+s)
            temp3=temp3*temp3
            go to 451
          end if
        end do
 451 &
        continue
        if(missed) then
          jstr=1
        else
          jstr=i
        end if
        do i=jstr,indvt
          j=wnjvt(i)
          if(j.gt.k) then
            norm_lt(j)=norm_lt(j)+wravt(i)*temp3*wravt(i)
          end if
        end do
!
!    -- get u_k:
!    -- 1) initialize u_k as u_k=x_k=e_k
!
        indu=1
        wnju(indu)=k
        wrau(indu)=one
        wnjuf(k)=indu
!
!    -- get u_k:
!    -- 2) update u_k by sparse SAXPY updates
!    --    corresponding to previous columns of U
!    --    U_{k}=X_{k}-sum_{kk=1}^{k-1}((V_{kk}k)/(sr_kk) U_kk)
!
        jstrt=vrow_ia(k)
        jstop=vrow_last(k)
        do kk=jstrt,jstop
          ii=vrow_ja(kk)
          temp=vrow_aa(kk)
          temp=temp/s
          if(temp.ne.zero) then
            istrt=iu(ii)   ! ii-th column of U
            istop=iu(ii+1) -1
            do i=istrt,istop
              j=ju(i)
              l=wnjuf(j)
              if(l.ne.n1) then
!
!            -- update
!
                wrau(l)=wrau(l)-temp*au(i)
              else
!
!            -- add
!
                indu=indu +1
                wrau(indu)=-temp*au(i)
                wnju(indu)=j
                wnjuf(j)=indu
              end if
            end do
          end if
        end do
!
!    -- get ut_k:
!    -- 1) initialize ut_k as ut_k=x_k=e_k
!
        indut=1
        wnjut(indut)=k
        wraut(indut)=one
        wnjuft(k)=indut
!
!    -- get ut_k:
!    -- 2) update ut_k by sparse SAXPY updates
!    --    corresponding to previous columns of U
!    --    Ut_{k}=X_{k}-sum_{kk=1}^{k-1}((V_{kk}k)/(sr_kk) U_kk)
!
        jstrt=vtrow_ia(k)
        jstop=vtrow_last(k)
        do kk=jstrt,jstop
          ii=vtrow_ja(kk)
          temp=vtrow_aa(kk)
          temp=temp/s
          if(temp.ne.zero) then
            istrt=iut(ii)   ! ii-th column of U
            istop=iut(ii+1) -1
            do i=istrt,istop
              j=jut(i)
              l=wnjuft(j)
              if(l.ne.n1) then
!
!            -- update
!
                wraut(l)=wraut(l)-temp*aut(i)
              else
!
!            -- add
!
                indut=indut +1
                wraut(indut)=-temp*aut(i)
                wnjut(indut)=j
                wnjuft(j)=indut
              end if
            end do
          end if
        end do
!
!    -- get the k-th pivot
!
        pivot=1+wrav(wnjvf(k))/s
!
!    -- test / modify / invert the pivot
!
        if(abs(pivot).lt.diagtol) then
          imodif=imodif+1
          if(pivot .gt. zero) then
            pivot=diagtol
          else
            pivot=-diagtol
          end if
        end if
        pivot=one/pivot
        diag(k)=pivot
!
!    -- get the k-th pivot
!
        pivott=1+wravt(wnjvft(k))/s
!
!    -- test / modify / invert the pivot
!
        if(abs(pivott).lt.diagtol) then
          imodift=imodift+1
          if(pivott .gt. zero) then
            pivott=diagtol
          else
            pivott=-diagtol
          end if
        end if
        pivott=one/pivott
        diagt(k)=pivott
!
!    -- scan and drop elements of u_k (k-th row of U)
!
        ind=0
        do i=1,indu
          temp=wrau(i)
          j=wnju(i)
          if((abs(temp).ge.drflu).or.(j.eq.k)) then
            ind=ind+1
            wrau(ind)=temp
            wnju(ind)=j
            wnjuf(j)=ind
          else
            wnjuf(j)=n1
          end if
        end do
        indu=ind
!
!    -- scale U by D^{-1}
!
        do i=1,indu
          wrau(i)=pivot*wrau(i)
        end do
!
!    -- update row structures for u
!
        do i=1,indu
          j=wnju(i)
          jstrt=urow_ia(j)
          jstop=urow_last(j)
          if(jstop.lt.jstrt+lsize-1) then
!
!        -- add an entry
!
            jstop=jstop+1
            urow_ja(jstop)=k
            urow_aa(jstop)=wrau(i)
            urow_last(j)=jstop
          else
!
!        -- sort entries and try to add
!
            temp=abs(wrau(i))
!
!        -- note: idamin should be replaced by something cheaper
!        -- (inline search)
!
            ii=idamin(jstop-jstrt+1,urow_aa(jstrt),1)
            if(temp.gt.abs(urow_aa(jstrt+ii-1))) then
              urow_ja(jstrt+ii-1)=k
              urow_aa(jstrt+ii-1)=wrau(i)
            end if
          end if
        end do
!
!    -- copy column u_k to u
!
        ind=iendu
        iendu=iendu+indu
        if(iendu.gt.max_u-1) then
          if(realloc.eq.1) then
            incr=min(max_u,int(dble(max_u)*dble(n)/dble(k)))
            call realli_a(ju,max_u,incr,newmax_u,ierr)
            call reallr_a(au,max_u,incr,newmax_u,ierr)
            max_u=newmax_u
            nreallocu=nreallocu+1
          else
            go to 401
          end if
        end if
        do i=1,indu
          ind=ind +1
          j=wnju(i)
          ju(ind)=j
          au(ind)=wrau(i)
          wnjuf(j)=n1
        end do
        iu(k+1)=ind+1

!
!    -- scan and drop elements of ut_k (k-th row of Ut)
!
        indt=0
        do i=1,indut
          temp=wraut(i)
          j=wnjut(i)
          if((abs(temp).ge.drflu).or.(j.eq.k)) then
            indt=indt+1
            wraut(indt)=temp
            wnjut(indt)=j
            wnjuft(j)=indt
          else
            wnjuft(j)=n1
          end if
        end do
        indut=indt
!
!    -- scale U by D^{-1}
!
        do i=1,indut
          wraut(i)=pivott*wraut(i)
        end do
!
!    -- update row structures for u
!
        do i=1,indut
          j=wnjut(i)
          jstrt=utrow_ia(j)
          jstop=utrow_last(j)
          if(jstop.lt.jstrt+lsize-1) then
!
!        -- add an entry
!
            jstop=jstop+1
            utrow_ja(jstop)=k
            utrow_aa(jstop)=wraut(i)
            utrow_last(j)=jstop
          else
!
!        -- sort entries and try to add
!
            temp=abs(wraut(i))
!
!        -- note: idamin should be replaced by something cheaper
!        -- (inline search)
!
            ii=idamin(jstop-jstrt+1,utrow_aa(jstrt),1)
            if(temp.gt.abs(utrow_aa(jstrt+ii-1))) then
              utrow_ja(jstrt+ii-1)=k
              utrow_aa(jstrt+ii-1)=wraut(i)
            end if
          end if
        end do
!
!    -- copy column u_k to u
!
        indt=iendut
        iendut=iendut+indut
        if(iendut.gt.max_ut-1) then
          if(realloct.eq.1) then
            incr=min(max_ut,int(dble(max_ut)*dble(n)/dble(k)))
            call realli_a(jut,max_ut,incr,newmax_ut,ierr)
            call reallr_a(aut,max_ut,incr,newmax_ut,ierr)
            max_ut=newmax_ut
            nreallocut=nreallocut+1
          else
            go to 401
          end if
        end if
        do i=1,indut
          indt=indt+1
          j=wnjut(i)
          jut(indt)=j
          aut(indt)=wraut(i)
          wnjuft(j)=n1
        end do
        iut(k+1)=indt+1
!
!    -- scan and drop elements of v_k
!
        ind=0
        temp2=norm_l(k)*diag(k)
        icount=0
        do i=1,indv
          temp=wrav(i)
          j=wnjv(i)
          if(j.lt.k) then
!
!        -- dropping in row of L^{-1}
!
!            if(abs(temp)*norm_invl(j).ge.drflv) then
            if(abs(temp)*norm_invl(j).ge.drflv.and.icount.le.lsiz2) then
              ind=ind+1
              icount=icount+1
              wrav(ind)=temp
              wnjv(ind)=j
              wnjvf(j)=ind
            else
              wnjvf(j)=n1
            end if
          elseif(j.eq.k) then
            ind=ind +1
            wrav(ind)=temp
            wnjv(ind)=j
            wnjvf(j)=ind
          else
!
!        -- dropping in scaled column of L
!
            if(abs(temp)*temp2.ge.drflv) then
              ind=ind +1
              wrav(ind)=temp
              wnjv(ind)=j
              wnjvf(j)=ind
            else
              wnjvf(j)=n1
            end if
          end if
        end do
        indv=ind
!
!    -- update row structures for v
!
        do i=1,indv
          j=wnjv(i)
          jstrt=vrow_ia(j)
          jstop=vrow_last(j)
          if(jstop.lt.jstrt+lsize-1) then
!
!        -- add an entry
!
            jstop=jstop+1
            vrow_ja(jstop)=k
            vrow_aa(jstop)=wrav(i)
            vrow_last(j)=jstop
          else
!
!        -- sort entries and try to add
!
            temp=abs(wrav(i))
            ii=idamin(jstop-jstrt+1,vrow_aa(jstrt),1)
            if(temp.gt.abs(vrow_aa(jstrt+ii-1))) then
              vrow_ja(jstrt+ii-1)=k
              vrow_aa(jstrt+ii-1)=wrav(i)
            end if
          end if
        end do
!
!    -- copy column v_k to v
!
        ind=iendv
        iendv=iendv+indv
        if(iendv.gt.max_v-1) then
          if(realloc.eq.1) then
            incr=min(max_v,int(dble(max_v)*dble(n)/dble(k)))
            call realli_a(jv,max_v,incr,newmax_v,ierr)
            call reallr_a(av,max_v,incr,newmax_v,ierr)
            max_v=newmax_v
            nreallocv=nreallocv+1
          else
            go to 401
          end if
        end if
        do i=1,indv
          ind=ind +1
          j=wnjv(i)
          jv(ind)=j
          av(ind)=wrav(i)
          wnjvf(j)=n1
        end do
        iv(k+1)=ind+1

!
!    -- scan and drop elements of vt_k
!
        indt=0
        icount=0
        temp2=norm_lt(k)*diagt(k)
        do i=1,indvt
          temp=wravt(i)
          j=wnjvt(i)
          if(j.lt.k) then
!
!        -- dropping in row of L^{-1}
!
           if(abs(temp)*norm_invlt(j).ge.drflv.and.icount.le.lsiz2) then
!            if(abs(temp)*norm_invlt(j).ge.drflv) then
              indt=indt +1
              icount=icount+1
              wravt(indt)=temp
              wnjvt(indt)=j
              wnjvft(j)=indt
            else
              wnjvft(j)=n1
            end if
          elseif(j.eq.k) then
            indt=indt +1
            wravt(indt)=temp
            wnjvt(indt)=j
            wnjvft(j)=indt
          else
!
!        -- dropping in scaled column of L
!
            if(abs(temp)*temp2.ge.drflv) then
              indt=indt+1
              wravt(indt)=temp
              wnjvt(indt)=j
              wnjvft(j)=indt
            else
              wnjvft(j)=n1
            end if
          end if
        end do
        indvt=indt
!
!    -- update row structures for vt
!
        do i=1,indvt
          j=wnjvt(i)
          jstrt=vtrow_ia(j)
          jstop=vtrow_last(j)
          if(jstop.lt.jstrt+lsize-1) then
!
!        -- add an entry
!
            jstop=jstop+1
            vtrow_ja(jstop)=k
            vtrow_aa(jstop)=wravt(i)
            vtrow_last(j)=jstop
          else
!
!        -- sort entries and try to add
!
            temp=abs(wravt(i))
            ii=idamin(jstop-jstrt+1,vtrow_aa(jstrt),1)
            if(temp.gt.abs(vtrow_aa(jstrt+ii-1))) then
              vtrow_ja(jstrt+ii-1)=k
              vtrow_aa(jstrt+ii-1)=wravt(i)
            end if
          end if
        end do
!
!    -- copy column vt_k to v
!
        indt=iendvt
        iendvt=iendvt+indvt
        if(iendvt.gt.max_vt-1) then
          if(realloct.eq.1) then
            incr=min(max_vt,int(dble(max_vt)*dble(n)/dble(k)))
            call realli_a(jvt,max_vt,incr,newmax_vt,ierr)
            call reallr_a(avt,max_vt,incr,newmax_vt,ierr)
            max_vt=newmax_vt
            nreallocvt=nreallocvt+1
          else
            go to 401
          end if
        end if
        do i=1,indvt
          indt=indt +1
          j=wnjvt(i)
          jvt(indt)=j
          avt(indt)=wravt(i)
          wnjvft(j)=n1
        end do
        ivt(k+1)=indt+1
!
        if(outlvl.ge.2) then
          if(k/100.eq.dble(k)/100.0d0) then
            write(*,*) k,iendu,iendv,iendut,iendvt
          end if
        end if
!
!  -- complete row norms of l
!
        norm_l(k)=norm_l(k)+one
        norm_l(k)=dsqrt(norm_l(k))
        norm_lt(k)=norm_lt(k)+one
        norm_lt(k)=dsqrt(norm_lt(k))
        norm_invl_max=max(norm_invl(k),norm_invl_max)
        norm_l_max=max(norm_l(k),norm_l_max)
        norm_invl_max=max(norm_invlt(k),norm_invl_max)
        norm_l_max=max(norm_lt(k),norm_l_max)
!
!    -- dynamic control of updates
!    -- (partial and primitive adaptiveness)
!
        drflv_update=max(drflv_update,  &
          drflv_standard*update_unsymmetry)
        if(k/100.eq.dble(k)/100.0d0) then
          if(no_updates.ge.2*(k/10)) then
            drflv_standard=2*drflv_standard
          end if
        end if
        drflv_dot=max(drflv_dot,         &
          drflv_standard*norm_invl_max/  &
          max(drflv_standard,update_unsymmetry))
        if(no_minor_updates.eq.0) then
          coef=max(coef-0.02d0,0.5d0)
        else
          coef=min(0.9d0,coef+0.02d0)
        end if
      end do
!
!  -- end of the main loop
!
      fillu=iu(n1)-1
      fillv=iv(n1)-1
      fillut=iut(n1)-1
      fillvt=ivt(n1)-1
      deallocate(iu,ju,au)
      deallocate(wnju,wnjuf,wrau)
      deallocate(wnjv,wrav)
      deallocate(urow_ia,urow_ja,urow_aa)
      deallocate(vrow_ia,vrow_ja,vrow_aa)
      deallocate(urow_last,vrow_last)
      deallocate(wn01,y,diag)
      deallocate(wnjvf,norm_l,norm_invl)
      deallocate(iut,jut,aut)
      deallocate(wnjut,wnjuft,wraut)
      deallocate(wnjvt,wravt)
      deallocate(utrow_ia,utrow_ja,utrow_aa)
      deallocate(vtrow_ia,vtrow_ja,vtrow_aa)
      deallocate(utrow_last,vtrow_last)
      deallocate(wn01t,yt,diagt)
      deallocate(wnjvft,norm_lt,norm_invlt)
      allocate(il(n+1),jl(max_l),al(max_l),stat=ierr)
      if(ierr.ne.0) go to 400
      allocate(ilt(n+1),jlt(max_lt),alt(max_lt),stat=ierr)
      if(ierr.ne.0) go to 400
!
!  -- get the factor of direct incomplete factorization
!  -- as V + W
!
      iendl=0
      ind=1
      do k=1,n
        indold=ind
        istrt=ivt(k)
        istop=ivt(k+1)-1
        needed=istop-istrt
        if(iendl+needed.gt.max_l-1) then
          if(realloc.eq.1) then
            incr=min(max_l,int(dble(max_l)*dble(n)/dble(k)))
            call realli_a(jl,max_l,incr,newmax_l,ierr)
            call reallr_a(al,max_l,incr,newmax_l,ierr)
            max_l=newmax_l
            nreallocl=nreallocl+1
          else
            go to 401
          end if
        end if
        do i=istrt,istop
          j=jvt(i)
          if(j.gt.k) then
            temp=avt(i)
            if(abs(temp).gt.drfll) then
              jl(ind)=j
              al(ind)=temp
              ind=ind+1
            end if
          elseif(j.eq.k) then
            temp=avt(i)
            jl(ind)=j
            al(ind)=temp+s
            ind=ind+1
          end if
        end do
        il(k)=indold
        iendl=ind-1
      end do
      il(n+1)=ind

!
!  -- get the factor of direct incomplete factorization
!  -- as V + W
!
      iendlt=0
      indt=1
      do k=1,n
        indoldt=indt
        istrt=iv(k)
        istop=iv(k+1)-1
        neededt=istop-istrt
        if(iendlt+neededt.gt.max_lt-1) then
          if(realloct.eq.1) then
            incr=min(max_lt,int(dble(max_lt)*dble(n)/dble(k)))
            call realli_a(jlt,max_lt,incr,newmax_lt,ierr)
            call reallr_a(alt,max_lt,incr,newmax_lt,ierr)
            max_lt=newmax_lt
            nrealloclt=nrealloclt+1
          else
            go to 401
          end if
        end if
        do i=istrt,istop
          j=jv(i)
          if(j.gt.k) then
            temp=av(i)
            if(abs(temp).gt.drfllt) then
              jlt(indt)=j
              alt(indt)=temp
              indt=indt+1
            end if
          elseif(j.eq.k) then
            temp=av(i)
            jlt(indt)=j
            alt(indt)=temp+s
            indt=indt+1
          end if
        end do
        ilt(k)=indoldt
        iendlt=indt-1
      end do
      ilt(n+1)=indt
!
!  -- sort factors
!
      call srtcs1(n,il,jl,al)
      call srtcs1(n,ilt,jlt,alt)
!
!  -- scale diagonal entries of U
!
      do i=1,n
        j=ilt(i)
        alt(j)=one/alt(j)
      end do
!
!  -- scale off-diagonal entries of L
!
      do i=1,n
        j=il(i)
        al(j)=one/al(j)
      end do
!
!    -- multiply off-diagonals
!
        do i=1,n
          istrt=il(i)
          istop=il(i+1)-1
          temp=al(il(i))
          do j=istrt+1,istop
            al(j)=al(j)*temp
          end do
        end do
!
      filll=il(n+1)-1
      filllt=ilt(n+1)-1
!
!  -- finalization
!
      deallocate(iv,jv,av)
      deallocate(ivt,jvt,avt)
!
      drfll=drfll-eps
      drfllt=drfllt-eps
!
!  -- return
!
      return
!
  400 continue
      info=8
      return
  401 continue
      info=1102 ! structures not sufficient
      return
!
! end of nbif_interleave_experiments_2008
!
      end subroutine nbif_interleave_experiments_2008



!
      end module ainv90

